Question

Unix Exit Codes

Asked by: bowemc

Hi,

I'm using a script to start my application on a daily basis. A cron-like application called Control-M calls this script at a give time and starts the app. The script istelf is very simple as you can see below.

However the line "Load app" occasionally has thrown an error which has resulted in "app.sh" failing to start up the applicartion. I need to check the "Load app" command has completed successfully before calling app.sh, otherwise abort.

How can I do this? Some one mention using exit codes, but I don't know how this works. any ideas?

#!/bin/ksh
. /apps/bin/0LOAD
Load app
app.sh

                                  
1:
2:
3:
4:

Select allOpen in new window

This Question has been solved and asker verified All Experts Exchange premium technology solutions are available to subscription members.

Subscribe now for full access to Experts Exchange and get

Instant Access to this Solution

  • Plus...
  • 30 Day FREE access, no risk, no obligation
  • Collaborate with the world's top tech experts
  • Unlimited access to our exclusive solution database
  • Never be left without tech help again

Subscribe Now

Asked On
2008-07-18 at 02:21:21ID23576208
Topics

KornShell (ksh)

,

Linux

,

Shell Scripting

Participating Experts
4
Points
500
Comments
8

Trusted by hundreds of thousands everyday for fast, accurate and reliable tech support.

  • "The time we save is the biggest benefit of Experts Exchange to Warner Bros. What could take multiple guys 2 hours or more each to find is accessed in around 15 minutes on Experts Exchange." Mike Kapnisakis, Warner Bros.
  • "Our team likes having a resource that is more secure than just using Google and most experts using this service really know their stuff. It's nice to look here first versus using Google." Dayna Sellner, Lockheed Martin
  • "Anytime that I've been stumped with a problem, 9 out of 10 times Experts Exchange has either the accepted solution or an open discussion of the potential solution to the problem." Kenny Red, eBay Inc.

See what Experts Exchange can do for you.

Got a question?

We've got the answer.

Experts Exchange has been collecting answers to technology questions since 1996…3 million and counting! If you have a question, chances are we already have your answer.

Screenshot of Experts Exchange Knowledgebase

Need individual assistance?

Our experts are ready to help.

If you can't find the exact answer you're looking for, ask our exclusive community of 50,000 experts. You’ll get a personalized answer from a trusted professional.

Screenshot of Experts Exchange Knowledgebase

Want to learn from the best?

Read articles from industry experts.

Thousands of free tech tips, tricks, how-to’s and tutorials are available in our peer reviewed articles section. See for yourself how smart our experts are, no login required.

Screenshot of an Article

Working on a long term project?

Store your work and research.

Save solutions to your questions, answers you’ve discovered through searching plus helpful articles in your personal knowledgebase for easy future access.

Screenshot of Experts Exchange Knowledgebase

Access the answers to your technology questions today.

Subscribe Now

30-day free trial. Register in 60 seconds.

What Makes Experts Exchange Unique?

Members of the expert community talk about why the experience at Experts Exchange is different than what you will find anywhere else.

Trusted by the world's most respected brands.

image of each brand's logo

Faithfully serving IT professionals since 1996.

Experts Exchange Logo

Try it out and discover for yourself.

Subscribe Now

30-day free trial. Register in 60 seconds.

Related Solutions

  1. Cron emulator/ faking cron
    Does anyone know a free script that will emulation the Unix cron utility. I am not allowed to use cron to automate action every day have to be done automatically. I would like it to use on a unix machine. Can I use the sleep function? Can someone help me to a script?
  2. Aborting Threads in ASP.NET - how to actually Abort ?
    We've got a situation within one of our ASP.NET web pages (with underlying C# code). From one form we're setting up and starting a Thread - and storing it in the 'Session' object. So far our code is something like : st = new Something(parameter1, parameter2); Thread t = ne...

Free Tech Articles

  1. WARNING: 5 Reasons why you should NEVER fix a computer for free.
    It is in our nature to love the puzzle. We are obsessed. The lot of us. We love puzzles. We love the challenge. We thrive on finding the answer. We hate disarray. It bothers us deep in our soul. W...
  2. SCCM OSD Basic troubleshooting
    SCCM 2007 OSD is a fantastic way to deploy operating systems, however, like most things SCCM issues can sometimes be difficult to resolve due to the sheer volume of logs to sift through and the dispe...
  3. Migrate Small Business Server 2003 to Exchange 2010 and Windows 2008 R2
    This guide is intended to provide step by step instructions on how to migrate from Small Business Server 2003 to Windows 2008 R2 with Exchange 2010. For this migration to work you will need the fo...
  4. Create a Win7 Gadget
    This article shows you how to create a simple "Gadget" -- a sort of mini-application supported by Windows 7 and Vista. Gadgets can be dropped anywhere on the desktop to provide instant information, ...
  5. Outlook continually prompting for username and password
    There have been a lot of questions recently regarding Outlook prompting for a username and password whilst using Exchange 2007. There are a few reasons why this would happen and I will try to cover t...
  6. Backup Exchange 2010 Information Store using Windows Backup
    There seems to be quite a lot of confusion around the ability to backup Exchange 2010 using the built in Windows Backup feature. This stems from the omission of this feature prior to Exchange 2007 s...

Cloud Class Webinars

  1. Avoiding Bugs in Microsoft Access
    Alison Balter takes and in-depth look at avoiding bugs in Access. In this webinar you will learn about using the immediate window to debug your applications, invoking the debugger, using breakpoints to troubleshoot, stepping through code, setting the next statement to execute, ...
  2. Top 10 Best New Features in Visio 2010
    Scott Helmers gives live demonstrations of the top 10 new features in Visio 2010. This webinar will teach you how to create compelling diagrams by adding shapes to the page with a single click, linking the shapes in a diagram to data in Excel (or SQL Server, or SharePoint), ...
  3. IT Consultant Business Secrets Revealed
    Michael Munger, Experts Exchange tech pro and IT consultant, pulls back the curtain on his very successful businesses and answers question on every IT consultant and business owner should know about. He shares secrets on what he did to solve the 5 most common problems in IT, ...
  4. Disaster Recovery and Business Continuity
    Quest CTO, Mike Billon, gives an overview of the steps involved in building a dunamic disaster recovery plan. Through case studies and an examination of software/hardware tooles for monitoring and testing, you'll gain a better understandin of where you are, where you want ...
  5. Organize Your Visio Diagrams with Containers and Lists
    Scott Helmers uses cross functional flowcharts, wireframe diagrams, data graphic legends and seating charts to teach you: how to ustilize all three new structured diagram components in Visio 2010, the best practices for organizeing shapes in previous version of Visio, how to organize ...
  6. How to Us Objects, Properties, Events and Methods in Microsoft Access
    Alison Dalter gives an in-depbth look at objects, properties, events and methods in Microsoft Access. In this webinar you will learn about using the object browser, referring to objects, working with properties and methods, working with object variables, understanding the ...

Join the Community

Give a Little. Get a Lot.

Join the community of experts here and help other tech pros by answering question in your area of expertise. You can earn FREE access to all Experts Exchange's premium features and resources.

Join the Community

Answers

 

by: wilhelm_voigtPosted on 2008-07-18 at 02:35:09ID: 22034058

It's covered here: http://www.bolthole.com/solaris/ksh-basics.html

The exit status is available in the variable $? directly after the call. So after line 3, you can include a block like the one described in the link above:

if [ $? -eq 0 ] ; then
	print we are okay
else
	print something failed
fi
                                              
1:
2:
3:
4:
5:

Select allOpen in new window

 

by: TintinPosted on 2008-07-18 at 03:01:42ID: 22034183

#!/bin/ksh
. /apps/bin/0LOAD
Load app || exit 1
app.sh

                                              
1:
2:
3:
4:

Select allOpen in new window

 

by: joolsPosted on 2008-07-18 at 08:12:22ID: 22036653

Couldnt you also do

#!/bin/ksh
. /apps/bin/0LOAD
Load app && app.sh
                                              
1:
2:
3:

Select allOpen in new window

 

by: joolsPosted on 2008-07-18 at 08:13:34ID: 22036668

or

#!/bin/ksh
. /apps/bin/0LOAD
Load app
if [[ $? = 0 ]]
then
   app.sh
else
   echo "Load app failed with error $?"
fi
                                              
1:
2:
3:
4:
5:
6:
7:
8:
9:

Select allOpen in new window

 

by: bowemcPosted on 2008-07-18 at 08:32:49ID: 22036899

what does Load app && app.sh do? I don't understand &&

 

by: joolsPosted on 2008-07-18 at 09:25:25ID: 22037469

I think.... from a somewhat failing memory...

Load app runs, if it runs successfully (ie return code 0) it will then run app.sh
If load app returns anything other than return code 0 app.sh will not run, this should be ok in most cases but if the Load app returns a valid (perhaps for a warning) non zero return code then it will not run app.sh in any case. But I guess that will be true of all the examples above anyway...

You may want to use something like the 2nd option in the "or" example, you may find it easier to read and debug if you have to.

 

by: agriesserPosted on 2008-07-18 at 10:41:54ID: 22038084

What does the error look like that's thrown by `Load App`? In some circumstances it might even be that this command throws an error but quits with exit code 0 (I saw that often with old or badly written software), that way you won't be able to track the error in that application.
If it produces output to the screen, you might need to `grep` the output and act accordingly, f.ex. if the `Load App` invocation prints out "Error 0x8cf" when it fails, a script like this might help:

#!/bin/ksh
. /apps/bin/0LOAD
if ! Load app 2>&1 | grep -q "Error 0x8cf"; then
  app.sh
fi

                                              
1:
2:
3:
4:
5:

Select allOpen in new window

 

by: TintinPosted on 2008-07-18 at 13:59:22ID: 22039757

&& is AND
|| is OR

So

cmd1 && cmd2

is a shortcut for

cmd1

if [ $? -eq 0 ]
then
    cmd1
fi

cmd1 || cmd2

is a shortcut for

cmd1

if [ $? -ne 0 ]
then
    cmd2
fi

20120131-EE-VQP-002

3 Ways to Join

30-Day Free Trial

The Experts

98% positive feedback on 31,087 answers since March 2000. angeliii is a Microsoft Most Valuable Professional for his work with MS SQL Server & Develoment.

He has also proven his knowledge of Visual Basic Programming, PHP Scripting and Oracle Databases.

The Experts

97% positive feedback on 10,752 answers since July 2000. lrmoore has more than 18 years experience in the networking industry.

The six-time Mircosoft MVPs specialties include firewalls, virtual private networking, and network management.

Testimonials

"...and excellent source for support... Kind of like having your very own IT dept." Electriciansnet

Testimonials

"I was apprehensive at signing up at first. However... it has already made my life as an IT administrator much easier." JaCrews

Testimonials

"WOW! You guys have great, active, and knowledgeable people on here." moore50

Business Clients

Business Clients

In the Press

"If you’ve got a question... Experts Exchange can supply an answer.”

In the Press

"...an invaluable aid for both IT professionals and those who require tech support."

In the Press

"where IT professionals provide quick answers on just about any topic"

Business Account Plans

Loading Advertisement...